summaryrefslogtreecommitdiff
path: root/tests/du
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2015-05-14 11:43:54 +0100
committerPádraig Brady <P@draigBrady.com>2015-05-14 14:08:02 +0100
commit7f0f58fdd68e7ca86dd5db7effb2c7f94adc4a08 (patch)
tree6b50d29fb53c6d45bc9f43330abe6bf6b87f6c81 /tests/du
parent45b8fe430dced8c489cb64491b8716cffeeca8c3 (diff)
downloadcoreutils-7f0f58fdd68e7ca86dd5db7effb2c7f94adc4a08.tar.xz
tests: fix async allocation race on BTRFS
* tests/dd/sparse.sh: Sync files before checking allocations, which may be done asynchronously on NFS and BTRFS at least. Also mark this test as very expensive on remote file systems. * tests/du/2g.sh: Likewise, also use fallocate if available to efficiently allocate the large file, otherwise skip on remote file systems. * tests/tail-2/inotify-rotate-resources.sh: Use the more standard is_local_dir_() to check remoteness. * tests/cp/fiemap-empty.sh: Comment on the sync issue for this currerntly unused test. Fixes http://bugs.gnu.org/20570
Diffstat (limited to 'tests/du')
-rwxr-xr-xtests/du/2g.sh26
1 files changed, 16 insertions, 10 deletions
diff --git a/tests/du/2g.sh b/tests/du/2g.sh
index 5f04488d6..12c2eede6 100755
--- a/tests/du/2g.sh
+++ b/tests/du/2g.sh
@@ -24,7 +24,6 @@ print_ver_ du
# Creating a 2GB file counts as 'very expensive'.
very_expensive_
-
# Get number of free kilobytes on current partition, so we can
# skip this test if there is insufficient free space.
free_kb=$(df -k --output=avail . | tail -n1)
@@ -42,15 +41,22 @@ test $min_kb -lt $free_kb ||
}
big=big
-rm -f $big
-{
- for i in $(seq 100); do
- # Note: 2147483648 == 2^31. Print floor(2^31/100) per iteration.
- printf %21474836s x || fail=1
- done
- # After the final iteration, append the remaining 48 bytes.
- printf %48s x || fail=1
-} > $big || fail=1
+
+if ! fallocate -l2G $big; then
+ rm -f $big
+ {
+ is_local_dir_ . || skip 'Not writing 2GB data to remote'
+ for i in $(seq 100); do
+ # Note: 2147483648 == 2^31. Print floor(2^31/100) per iteration.
+ printf %21474836s x || fail=1
+ done
+ # After the final iteration, append the remaining 48 bytes.
+ printf %48s x || fail=1
+ } > $big || fail=1
+fi
+
+# The allocation may be done asynchronously (BTRFS for example)
+sync $big || framework_failure_
du -k $big > out1 || fail=1
rm -f $big